// Copyright (c) 1997 HARADA Masanori. All rights reserved.
//
// $Id: Coder.h,v 0.9 1997-12-27 07:08:29+09 harada Exp $
//
#ifndef CODER_H_INCLUDED
#define CODER_H_INCLUDED

extern "C" {
#include <stdlib.h>
}

class Coder {
private:
    // bit I/O
    char *bufp;
    const char *inbufp;
    int flush_need;
    int bit_out_cnt;
    int bit_out_byte;
    int bit_out(int bit);
    void bit_flush(){ while(bit_out(0) != 0); }
    int bit_in_filt;
    int bit_in_byte;
    int bit_in();
    void reset(){
        bit_out_cnt = 0; bit_out_byte = 0;
        bit_in_filt = 1; bit_in_byte = 0;
    };

    inline int i_log(int num, int &filt);
    void fit_code(int code, int filt);
    void gamma_code(int code);
    void delta_code(int code);
    unsigned int get_gamma();
    unsigned int get_delta();
public:
    Coder(){ }
    virtual ~Coder(){ }
    char *pack(const unsigned int *src, int srcNum,
               char *dstbuf, size_t dstsize, size_t &resultsize);
    char *diffpack(const unsigned int *src, int srcNum,
                   char *dstbuf, size_t dstsize, size_t &resultsize);
    size_t unpack(const char *src, unsigned int *dstbuf, int dstNum);
    size_t unpack(const char *src, int srcLen, unsigned int *dstbuf);
    size_t diffunpack(const char *src, unsigned int *dstbuf, int dstNum);
    int diffunpack(const char *src, int srcLen,
                   unsigned int *dstbuf, int dstLen);
    static void sort(unsigned int *array, int arrayNum);
};

// п log2 num ֤. filt = 2^(log2 num)
inline int
Coder::i_log(int num, int &filt){
    int i = 0;
    for(filt = 1; filt <= num; i++) filt = filt << 1;
    return i;
}


#endif
