// Copyright (c) 1997 HARADA Masanori. All rights reserved.
//
// $Id: Description.h,v 0.10 1998-01-08 01:46:30+09 harada Exp $
//
#ifndef DESCRIPTION_H_INCLUDED
#define DESCRIPTION_H_INCLUDED

#include <iostream.h>
#include <fstream.h>
extern "C" {
#include <time.h>
}
#include "Result.h"
#include "config.h"

class Description {
protected:
    fstream &file;
    const int blksize;
public:
    enum { MAXDATESTR = 64 };
    Description(fstream &f, int bs = DSCBLOCKSIZE) : file(f), blksize(bs) { }
    virtual ~Description() {
        if(file.is_open()) file.close();
    }
    virtual void getblock(int n, time_t &date, time_t &lastmodified,
                          size_t &sz, char *url,
                          char *author, char *title, char *digest);
    virtual void print(ostream &out, const Result &result);
    virtual void printHtml(ostream &out, const Result &result);
    static const char *rfc822date(char *buf, size_t bufsiz, time_t &t);
};

class HtmlDescription : public Description {
public:
    HtmlDescription(fstream &f) : Description(f, DSCBLOCKSIZE) { }
    virtual ~HtmlDescription() { }
    virtual void print(ostream &out, const Result &result);
    virtual void printHtml(ostream &out, const Result &result);
};

class MailDescription : public Description {
public:
    MailDescription(fstream &f) : Description(f, DSCBLOCKSIZE) { }
    virtual ~MailDescription() { }
    virtual void print(ostream &out, const Result &result);
    virtual void printHtml(ostream &out, const Result &result);
};

#endif
