// Copyright (c) 1997 HARADA Masanori. All rights reserved.
//
// $Id: LexiconEntry.h,v 0.9 1997-12-27 07:19:35+09 harada Exp $
//
#ifndef LEXICONENTRY_H_INCLUDED
#define LEXICONENTRY_H_INCLUDED

#include "IndexFile.h"
#include "typedef.h"

class LexiconEntry {
    friend ostream& operator<<(ostream &stream, const LexiconEntry &entry);
    friend istream& operator>>(istream &stream, LexiconEntry &entry);
private:
    enum entrytype { NULLENTRY = 0,
                     REFERENCEENTRY = 1,
                     XREFERENCEENTRY = 2,
                     ENTITYENTRY1 = 3,
                     ENTITYENTRY2 = 4,
                     ENTITYENTRY3 = 5,
                     ENTITYENTRY4 = 6,
                     ENTITYENTRY5 = 7,
                     MAXENTRYTYPE = 8 };
    char *key;
    blockno_t bn;
    recno_t rn;
    pos_t *values;
    int valueNum;
public:
    LexiconEntry();
    LexiconEntry(const LexiconEntry &that);
    LexiconEntry(const char *keystr,
                 blockno_t b = (blockno_t)-1,
                 recno_t r = (recno_t)-1);
    LexiconEntry(const char *keystr, const pos_t *list, int listLen);
    virtual ~LexiconEntry();
    void printDebug(ostream &out = cout) const;
    bool withValue() const { return valueNum != 0; }
    blockno_t getbn() const { return bn; }
    recno_t getrn() const { return rn; }
    LexiconEntry & operator =(const LexiconEntry &that);
    operator bool() const { return key != NULL; }
    operator const char *() const { return key; }
    const char *getkey() const { return key; }
    pos_t * fetch(IndexFile &indexfile, int &listLen) const;
    LexiconEntry &store(IndexFile &indexfile,
                        const pos_t *list, int ListLen);
};

#endif
