// Copyright (c) 1997 HARADA Masanori. All rights reserved.
//
// $Id: LexiconFile.h,v 0.9 1997-12-27 07:20:20+09 harada Exp $
//

// TODO: ǥˤĤƲͤƤʤ

#ifndef LEXICONFILE_H_INCLUDED
#define LEXICONFILE_H_INCLUDED

#include <iostream.h>
#include <fstream.h>
#include "LexiconEntry.h"

class LexiconFile {
    // friend class LexiconManager
private:
    enum { HEADERSIZE = 256, MAXPREFIXMATCH = 32 };
    static char MAGIC[];
    fstream &file;
    size_t filesize;
    const int readonly;
    char *headerbuf;
    size_t *offsetTbl;

    int findRegion(const char *key, size_t &from, size_t &to);
    int indexhash(const char *key);
    int writeHeader();
    int readHeader();
public:
    // enum { EXACTMATCH = 0, PREFIXMATCH = 1, FINDPREFIXES = 2 };
    LexiconFile(fstream &f, int rdonly, int newfile);
    virtual ~LexiconFile();

    int search(const char *key, LexiconEntry &result);
    LexiconEntry **prefixsearch(const char *key, int &n);
    int findPrefix(const char *text, LexiconEntry &result);
    istream &rewind();
    void prepareAppend();
    int appendEntry(const LexiconEntry &entry);
    void printDebug(ostream &out = cout) const;
};

#endif
