// Copyright (c) 1997 HARADA Masanori. All rights reserved.
//
// $Id: Word.h,v 0.9 1997-12-27 07:25:40+09 harada Exp $
//
#ifndef WORD_H_INCLUDED
#define WORD_H_INCLUDED

#include <iostream.h>
extern "C" {
#include <string.h>
}
#include "HashKey.h"

class Word : public HashKey {
    friend ostream& operator <<(ostream &stream, Word &w);
    friend bool operator ==(const Word &foo, const Word &bar);
    friend bool operator !=(const Word &foo, const Word &bar);
    friend bool operator >=(const Word &foo, const Word &bar);
    friend bool operator <=(const Word &foo, const Word &bar);
    friend bool operator >(const Word &foo, const Word &bar);
    friend bool operator <(const Word &foo, const Word &bar);
protected:
    char *buf;
    int cmp(const Word &that) const;
public:
    Word() : buf(NULL){}
    Word(const char *str){
        buf = new char[strlen(str) + 1];
        strcpy(buf, str);
    }
    Word(const char *str, int strLen){
        buf = new char[strLen + 1];
        strncpy(buf, str, strLen);
        buf[strLen] = '\0';
    }
    ~Word(){
        if(buf) delete[]buf;
    }
    const Word & operator =(const Word &that);
    operator const char *() const { return buf; }
    operator bool() const { return buf != NULL; }
    const char *toString() const { return buf ? buf : ""; }

    int operator ==(const HashKey &that) const {
        return (0 == strcmp(buf, that.toString()));
    }
    int operator ==(const Word &that) const {
        return 0 == cmp(that);
    }
    HashKey *clone() const { return new Word(buf); }
    unsigned int hashCode() const;
    int length() const { return strlen(buf); }
    int paste(char *to) const;
};

#endif
