// Copyright (c) 1997 HARADA Masanori. All rights reserved.
//
// miscellaneous (especially system dependent) definitions
// $Id: config.h,v 0.14 1998-01-24 23:39:57+09 harada Exp $
//
#ifndef CONFIG_H_INCLUDED
#define CONFIG_H_INCLUDED

#ifndef __USE_FIXED_PROTOTYPES__
#define __USE_FIXED_PROTOTYPES__
#endif

#define FREYABANNER "Freya version 0.92 (1998/Jan/24)"
#ifndef DEFAULT_MORPHDIC_PATH
#define DEFAULT_MORPHDIC_PATH "/usr/local/lib/freya/dict/icot.dic"
#endif

#include <limits.h>
#ifndef PATH_MAX
#include <sys/param.h>
#ifdef MAXPATHLEN
#define PATH_MAX MAXPATHLEN
#else
#define PATH_MAX 255
#endif // MAXPATHLEN
#endif // PATH_MAX

#ifndef LINE_MAX
#define LINE_MAX 2048
#endif // LINE_MAX

#ifndef NAME_MAX
#define NAME_MAX 255
#endif // NAME_MAX

#ifdef SUNOS4
#include <errno.h>
extern const char * const sys_errlist[];
inline const char *
mystrerror(int errnum){ return sys_errlist[errnum]; }
extern "C" int strcasecmp(char *s1, char *s2);
extern "C" int strncasecmp(char *s1, char *s2, int count);
extern "C" int flock(int, int);
#else  // SUNOS4
#include <string.h>
inline const char *
mystrerror(int errnum){ return strerror(errnum); }
#endif // SUNOS4

#include <iostream.h>
extern int errno;
#define PRINTERR() \
cerr << __FILE__ << '(' << __LINE__ << ") " << mystrerror(errno) << endl;

#define PRINTERRMSG(msg) \
cerr << __FILE__ << '(' << __LINE__ << ") " \
<< mystrerror(errno) << ": " << msg << endl;

//
// parameters
//
enum freya_params {
    DSCBLOCKSIZE = 256,
    RESULTSFORDISPLAY = 20,
    MAXRESULTSFORDISPLAY = 200,
    MAXWORDSINPHRASE = 16,
    MAXQUERIESINEXPRESSION = 32,
    MAXKEYLENGTH = 64,
    MAXQUERYLENGTH = (64 * 32),
    MAXSOURCELINELENGTH = (2 * LINE_MAX),
    MAXSORTRESULTS = 16384,
#ifdef ODIN
    MAXBUFFERINGWORDS = (1024 * 128)
#else
    MAXBUFFERINGWORDS = (1024 * 32) // EDIT HERE IF YOU WANT
#endif
};

#endif // CONFIG_H_INCLUDED
